0 REM '128 Screen Copier' part off '128 PRINTER TOOLKIT'
0 REM https://live.worldofspectrum.org/infoseek/magazines/zx-computing/37 PAGE 70+71

0 REM The Spectrum 128 RS232 printer port is mastered by S. J. Nutting
0 REM There are three routines in this tool-kit, all of which are desgined to make the operation of a printer via the 128's RS232 port much easier than it currently is.
0 REM The printer used was the Brother M1009 which is fairly Epson standard and, where necessary the ability to modify the program for other printer codes is included.
0 REM  Screen Copier
0 REM Type in the program and run it. Answer the prompts, either by pressing ENTER to accept the set
0 REM codes or type in your own (one at a time) and the programme will set up the code at address 65100. You will need to reload it before you can make screen copies.
0 REM Not only can you copy the whole screen but also sections of your choice. Before using the routine you will have to set up the screen area required by POKEing the following addresses,
0 REM POKE 65317,x
0 REM POKE 65318,y
0 REM POKE 65319,chars_across
0 REM POKE 65320,chars_down
0 REM The x,y,chars_across,chars_down variables need to be re-placed by numbers representing:
0 REM y - the starting position down the screen
0 REM x - the starting position across the screen
0 REM chars_across - the number of characters across that you want printed
0 REM chars_down - the number of lines down the screen from the start position that you wish to print.
0 REM EG to set up a whole screen: x=0:y=0:chars_across=32:chars_down=24 (see fig 1).

  10 CLEAR 65099: LET c=0:  FOR a=65100 TO 65332: READ n: POKE a,n: LET c=c+n: NEXT a

  20 IF c<>27505 THEN  PRINT "DATA ERROR": STOP

  30 DATA 205,207,254,33,53,255,205,18,255,33,56,255,205,18,255,58,39,255,111,38,0,41,41,41,41,34,41,255,33,37,255,229,205,222,254,225,205,243,254
  
  40 DATA 33,62,255,205,18,255,33,41,255,126,205,27,255,35,126,205,27,255,58,39,255,245,62,134,222,8,50,160,254,254,62,40,32,245,175,42,43,255

  50 DATA 221,33,45,255,6,8,203,126,40,3,221,134,0,221,35,36,16,244,205,27,255,205,27,255,241,24,215,42,43,255,35,34,43,255,241,61,32,201,33,59,255

  60 DATA 205,18,255,33,37,255,52,33,40,255,53,32,153,33,0,88,1,0,3,203,190,35,11,120,177,200,24,247,70,35,78,120,230,248,198,64,103,120,230,7,15,15,15

  70 DATA 129,111,34,43,255,201,70,35,78,120,203,47,203,47,203,47,198,88,103,120,230,7,15,15,15,129,111,58,39,255,203,254,35,61,32,250,201,70,35,126,205,27,255,16,249,201,229,197,245,205,66,255,241,193,225,201,0,0,32,24,0,0,0,0,128,64,32,16,8,4,2,1

  80 RESTORE 130: LET add=65333: LET e$="Press ENTER after each byte has been inputed pressing just ENTERwill go on to the next set of   inputs"

  90 CLS : READ memory: READ t$: IF memory=0 THEN  POKE add-a,0: PRINT "SAVE MACHINE CODE with"'"SAVE""mc"" CODE 65100,";add-65100: STOP

 100 PRINT AT 21,0;: RANDOMIZE add: POKE  memory,PEEK 23670: POKE memory+1,PEEK 23671

 110 PRINT AT 16,0;e$'+t$: FOR a=1 TO 50: INPUT b$: IF b$<>"" THEN  POKE add+a,VAL b$: PRINT b$;" ";: NEXT a

 120 POKE add,a-1: LET add=add+a: GO TO 90
 130 DATA 65104
 140 DATA "Initalise printer codes 27 64"
 150 DATA 65110
 160 DATA "Line feeds codes 27 49"
 170 DATA 65216
 180 DATA "Carriage return codes 10 13"
 190 DATA 65140
 200 DATA "Bit Image codes 27 42 1"
 210 DATA 65311
 220 DATA "Output A reg routine"+CHR$ 13+" end with 201 (RET)"
 230 DATA 0," "
